<template>
   <HeaderView title="Inwestycje w Gminie Gnojnik od 2015 roku" />
   <main>
      <Map :markers="store.data" />
      <div class="wrapper">
         <p>Inwestycje</p>
         <Selects ref="selects"></Selects>
         <TableView @show-dialog="openDialog">
            <tr>
               <th>Nazwa</th>
               <th>Koszt</th>
               <th>Miejscowość</th>
               <th>Typ</th>
               <th>Rok inwestycji</th>
               <th>Pokaż szczegóły</th>
               <th>Pokaż na mapie</th>
            </tr>
            <tr v-for="item in store.data" :key="item.name">
               <td>{{ item.name }}</td>
               <td>{{ item.cost }} zł</td>
               <td>{{ item.place.name }}</td>
               <td>{{ item.type.name }}</td>
               <td>{{ item.year.substring(0, 4) }}</td>
               <td><button @click="openDialog(item)">Pokaż</button></td>
               <td><button>Pokaż</button></td>
            </tr>
            <tr>
               <td>Suma:</td>
               <td colspan="6">{{ store.sum }} zł</td>
            </tr>
         </TableView>
         <TableView>
            <tr>
               <td></td>
               <th v-for="village in store.villages" :key="village.id">{{ village.name }}</th>
            </tr>
            <tr v-for="types in store.types" :key="types.id">
               <td>{{ types.name }}</td>
               <td v-for="village in store.villages" :key="village.id">
                  {{ store.getSumForVillage(village.name, types.id) }} zł
               </td>
            </tr>
            <tr>
               <td>Suma całkowita:</td>
               <td colspan="7">{{ store.totalSum }} zł</td>
            </tr>
         </TableView>
      </div>
   </main>
   <DialogWindow v-if="showDialog" :item="dataOfItem" @close="closeDialog">
      <div>Stopień Dofinansowania: {{ dataOfItem.external_financing_percent }} %</div>
   </DialogWindow>
</template>

<script setup lang="ts">
import { onMounted, ref } from "vue"
import TableView from "@/components/TableView.vue"
import Map from "@/components/MapView.vue"
import DialogWindow from "@/components/DialogWindow.vue"
import Selects from "@/views/Investments/SelectsView.vue"
import HeaderView from "@/components/HeaderView.vue"
import { useInvestments, type IInvestmens } from "@/views/Investments/store"

const showDialog = ref<boolean>(false),
   selects = ref<typeof Selects>(),
   store = useInvestments()
let dataOfItem: IInvestmens

function openDialog(item: IInvestmens) {
   showDialog.value = true
   dataOfItem = item
}
function closeDialog() {
   showDialog.value = false
}

onMounted(() => {
   setTimeout(() => {
      selects.value?.clear()
   }, 10000)
})
</script>

<style scoped>
main {
   box-sizing: border-box;
   display: flex;
   width: 100%;
   justify-content: space-between;
   border-top: 1px solid var(--border-color);
}

.wrapper {
   flex: 1;
   width: 100%;
   padding: 1rem;
}
@media (max-width: 550px) {
   .wrapper {
      width: 100%;
      padding: 0;
      height: 100%;
   }
}
</style>
